package com.ema.admin.modules.system.controller;

import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSON;
import cn.hutool.json.JSONUtil;
import com.mybatisflex.core.paginate.Page;
import com.ema.admin.modules.system.entity.SysDictData;
import com.ema.admin.modules.system.service.SysDictDataService;
import com.ema.admin.modules.system.vo.SysDictDataQueryVo;
import com.ema.common.exceptions.MyAssert;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 系统字典值表 控制层。
 *
 * @author lijian
 * @since 2025-07-31
 */
@RestController
@Api(tags = "系统字典值表接口")
@RequestMapping("/sysDictData")
public class SysDictDataController {

    @Autowired
    private SysDictDataService sysDictDataService;

    /**
     * 添加系统字典值表。
     *
     * @param sysDictData 系统字典值表
     * @return {@code true} 添加成功，{@code false} 添加失败
     */
    @PostMapping("save")
    @ApiOperation("保存系统字典值表")
    public boolean save(@RequestBody @ApiParam("系统字典值表") SysDictData sysDictData) {
        SysDictData data = sysDictDataService.getByCode(sysDictData.getTypeCode(), sysDictData.getCode());
        MyAssert.isNull(data, "字典编码已存在");
        return sysDictDataService.save(sysDictData);
    }

    /**
     * 根据主键删除系统字典值表。
     *
     * @param id 主键
     * @return {@code true} 删除成功，{@code false} 删除失败
     */
    @DeleteMapping("remove/{id}")
    @ApiOperation("根据主键系统字典值表")
    public boolean remove(@PathVariable @ApiParam("系统字典值表主键") String id) {
        return sysDictDataService.removeById(id);
    }

    /**
     * 根据主键更新系统字典值表。
     *
     * @param sysDictData 系统字典值表
     * @return {@code true} 更新成功，{@code false} 更新失败
     */
    @PutMapping("update")
    @ApiOperation("根据主键更新系统字典值表")
    public boolean update(@RequestBody @ApiParam("系统字典值表主键") SysDictData sysDictData) {
        SysDictData data = sysDictDataService.getByCode(sysDictData.getTypeCode(), sysDictData.getCode());
        MyAssert.isTrue(data == null || data.getId().equals(sysDictData.getId()), "字典编码已存在");
        return sysDictDataService.updateById(sysDictData);
    }

    /**
     * 查询所有系统字典值表。
     *
     * @return 所有数据
     */
    @GetMapping("list")
    @ApiOperation("查询所有系统字典值表")
    public List<SysDictData> list() {
        return sysDictDataService.list();
    }

    /**
     * 根据系统字典值表主键获取详细信息。
     *
     * @param id 系统字典值表主键
     * @return 系统字典值表详情
     */
    @GetMapping("getInfo/{id}")
    @ApiOperation("根据主键获取系统字典值表")
    public SysDictData getInfo(@PathVariable @ApiParam("系统字典值表主键") String id) {
        return sysDictDataService.getById(id);
    }

    /**
     * 分页查询系统字典值表（带条件）。
     *
     * @param queryVo 查询条件
     * @return 分页对象
     */
    @PostMapping("page")
    @ApiOperation("分页查询系统字典值表（带条件）")
    public Page<SysDictData> page(@RequestBody @ApiParam("查询条件") SysDictDataQueryVo queryVo) {
        return sysDictDataService.page(queryVo);
    }

    /**
     * 获取字典数据信息（字典类型+字典编码）
     *
     * @param typeCode 字典类型
     * @param dictCode 字典编码
     * @return 字典数据信息
     */
    @GetMapping("getData/{typeCode}/{dictCode}")
    @ApiOperation("获取字典数据信息（字典类型+字典编码）")
    public JSON getDictData(@PathVariable @ApiParam("字典类型") String typeCode, @PathVariable @ApiParam("字典编码") String dictCode) {
        SysDictData dictData = sysDictDataService.getByCode(typeCode, dictCode);
        MyAssert.notNull(dictData, "字典数据不存在");
        String dictValue = dictData.getValue();
        if(StrUtil.startWith(dictValue, "[") && StrUtil.endWith(dictValue, "]")){
            return JSONUtil.parseArray(dictValue);
        }else if(StrUtil.startWith(dictValue, "{") && StrUtil.endWith(dictValue, "}")){
            return JSONUtil.parseObj(dictValue);
        }
        return JSONUtil.createObj().set("value", dictValue);
    }

    /**
     * 获取字典数据列表（字典类型）
     *
     * @param typeCode 字典类型
     * @return 字典数据列表
     */
    @GetMapping("getList/{typeCode}")
    @ApiOperation("获取字典数据列表（字典类型）")
    public List<SysDictData> getDictDataList(@PathVariable @ApiParam("字典类型") String typeCode) {
        return sysDictDataService.queryChain().eq(SysDictData::getTypeCode, typeCode).list();
    }
}
